/* GeoLocate.c generated by valac 0.56.15, the Vala compiler
 * generated from GeoLocate.vala, do not modify */

/*
* Copyright (c) 2017-2018 Carlos Suárez (https://gitlab.com/bitseater)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; If not, see <http://www.gnu.org/licenses/>.
*
* Authored by: Carlos Suárez <bitseater@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <gio/gio.h>
#include <libsoup/soup.h>
#include <json-glib/json-glib.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>

#define CONSTANTS_OWM_API_ADDR "http://api.openweathermap.org/data/2.5/"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define METEO_UTILS_TYPE_COORD (meteo_utils_coord_get_type ())
typedef struct _MeteoUtilsCoord MeteoUtilsCoord;

#define METEO_UTILS_TYPE_GEO_LOC (meteo_utils_geo_loc_get_type ())
typedef struct _MeteoUtilsGeoLoc MeteoUtilsGeoLoc;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_SoupBuffer_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupBuffer_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MeteoUtilsCoord {
	gdouble lat;
	gdouble lon;
};

struct _MeteoUtilsGeoLoc {
	gchar* city;
	gchar* state;
	gchar* country;
};

VALA_EXTERN GType meteo_utils_coord_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MeteoUtilsCoord* meteo_utils_coord_dup (const MeteoUtilsCoord* self);
VALA_EXTERN void meteo_utils_coord_free (MeteoUtilsCoord* self);
VALA_EXTERN GType meteo_utils_geo_loc_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MeteoUtilsGeoLoc* meteo_utils_geo_loc_dup (const MeteoUtilsGeoLoc* self);
VALA_EXTERN void meteo_utils_geo_loc_free (MeteoUtilsGeoLoc* self);
VALA_EXTERN void meteo_utils_geo_loc_copy (const MeteoUtilsGeoLoc* self,
                               MeteoUtilsGeoLoc* dest);
VALA_EXTERN void meteo_utils_geo_loc_destroy (MeteoUtilsGeoLoc* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (MeteoUtilsGeoLoc, meteo_utils_geo_loc_destroy)
VALA_EXTERN void meteo_utils_geolocate (void);
VALA_EXTERN void meteo_utils_get_location (MeteoUtilsCoord* result);
VALA_EXTERN void meteo_utils_get_names (gdouble lat,
                            gdouble lon,
                            MeteoUtilsGeoLoc* result);
VALA_EXTERN gint64 meteo_utils_update_id (const gchar* uri);
static void _vala_SoupBuffer_free (SoupBuffer* self);

MeteoUtilsCoord*
meteo_utils_coord_dup (const MeteoUtilsCoord* self)
{
	MeteoUtilsCoord* dup;
#line 21 "../src/Utils/GeoLocate.vala"
	dup = g_new0 (MeteoUtilsCoord, 1);
#line 21 "../src/Utils/GeoLocate.vala"
	memcpy (dup, self, sizeof (MeteoUtilsCoord));
#line 21 "../src/Utils/GeoLocate.vala"
	return dup;
#line 105 "GeoLocate.c"
}

void
meteo_utils_coord_free (MeteoUtilsCoord* self)
{
#line 21 "../src/Utils/GeoLocate.vala"
	g_free (self);
#line 113 "GeoLocate.c"
}

static GType
meteo_utils_coord_get_type_once (void)
{
	GType meteo_utils_coord_type_id;
	meteo_utils_coord_type_id = g_boxed_type_register_static ("MeteoUtilsCoord", (GBoxedCopyFunc) meteo_utils_coord_dup, (GBoxedFreeFunc) meteo_utils_coord_free);
	return meteo_utils_coord_type_id;
}

GType
meteo_utils_coord_get_type (void)
{
	static volatile gsize meteo_utils_coord_type_id__once = 0;
	if (g_once_init_enter (&meteo_utils_coord_type_id__once)) {
		GType meteo_utils_coord_type_id;
		meteo_utils_coord_type_id = meteo_utils_coord_get_type_once ();
		g_once_init_leave (&meteo_utils_coord_type_id__once, meteo_utils_coord_type_id);
	}
	return meteo_utils_coord_type_id__once;
}

void
meteo_utils_geo_loc_copy (const MeteoUtilsGeoLoc* self,
                          MeteoUtilsGeoLoc* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
#line 26 "../src/Utils/GeoLocate.vala"
	_tmp0_ = (*self).city;
#line 26 "../src/Utils/GeoLocate.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 26 "../src/Utils/GeoLocate.vala"
	_g_free0 ((*dest).city);
#line 26 "../src/Utils/GeoLocate.vala"
	(*dest).city = _tmp1_;
#line 26 "../src/Utils/GeoLocate.vala"
	_tmp2_ = (*self).state;
#line 26 "../src/Utils/GeoLocate.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 26 "../src/Utils/GeoLocate.vala"
	_g_free0 ((*dest).state);
#line 26 "../src/Utils/GeoLocate.vala"
	(*dest).state = _tmp3_;
#line 26 "../src/Utils/GeoLocate.vala"
	_tmp4_ = (*self).country;
#line 26 "../src/Utils/GeoLocate.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 26 "../src/Utils/GeoLocate.vala"
	_g_free0 ((*dest).country);
#line 26 "../src/Utils/GeoLocate.vala"
	(*dest).country = _tmp5_;
#line 170 "GeoLocate.c"
}

void
meteo_utils_geo_loc_destroy (MeteoUtilsGeoLoc* self)
{
#line 27 "../src/Utils/GeoLocate.vala"
	_g_free0 ((*self).city);
#line 28 "../src/Utils/GeoLocate.vala"
	_g_free0 ((*self).state);
#line 29 "../src/Utils/GeoLocate.vala"
	_g_free0 ((*self).country);
#line 182 "GeoLocate.c"
}

MeteoUtilsGeoLoc*
meteo_utils_geo_loc_dup (const MeteoUtilsGeoLoc* self)
{
	MeteoUtilsGeoLoc* dup;
#line 26 "../src/Utils/GeoLocate.vala"
	dup = g_new0 (MeteoUtilsGeoLoc, 1);
#line 26 "../src/Utils/GeoLocate.vala"
	meteo_utils_geo_loc_copy (self, dup);
#line 26 "../src/Utils/GeoLocate.vala"
	return dup;
#line 195 "GeoLocate.c"
}

void
meteo_utils_geo_loc_free (MeteoUtilsGeoLoc* self)
{
#line 26 "../src/Utils/GeoLocate.vala"
	meteo_utils_geo_loc_destroy (self);
#line 26 "../src/Utils/GeoLocate.vala"
	g_free (self);
#line 205 "GeoLocate.c"
}

static GType
meteo_utils_geo_loc_get_type_once (void)
{
	GType meteo_utils_geo_loc_type_id;
	meteo_utils_geo_loc_type_id = g_boxed_type_register_static ("MeteoUtilsGeoLoc", (GBoxedCopyFunc) meteo_utils_geo_loc_dup, (GBoxedFreeFunc) meteo_utils_geo_loc_free);
	return meteo_utils_geo_loc_type_id;
}

GType
meteo_utils_geo_loc_get_type (void)
{
	static volatile gsize meteo_utils_geo_loc_type_id__once = 0;
	if (g_once_init_enter (&meteo_utils_geo_loc_type_id__once)) {
		GType meteo_utils_geo_loc_type_id;
		meteo_utils_geo_loc_type_id = meteo_utils_geo_loc_get_type_once ();
		g_once_init_leave (&meteo_utils_geo_loc_type_id__once, meteo_utils_geo_loc_type_id);
	}
	return meteo_utils_geo_loc_type_id__once;
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 256 "GeoLocate.c"
}

void
meteo_utils_geolocate (void)
{
	GSettings* setting = NULL;
	GSettings* _tmp0_;
	gchar* uri1 = NULL;
	gchar* _tmp1_;
	gchar* uri2 = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	MeteoUtilsCoord mycoords = {0};
	MeteoUtilsCoord _tmp6_ = {0};
	MeteoUtilsGeoLoc mygeoloc = {0};
	MeteoUtilsCoord _tmp7_;
	MeteoUtilsCoord _tmp8_;
	MeteoUtilsGeoLoc _tmp9_ = {0};
	gchar* uri = NULL;
	MeteoUtilsCoord _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	MeteoUtilsCoord _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	MeteoUtilsGeoLoc _tmp26_;
	const gchar* _tmp27_;
	MeteoUtilsGeoLoc _tmp28_;
	const gchar* _tmp29_;
	MeteoUtilsGeoLoc _tmp30_;
	const gchar* _tmp31_;
#line 33 "../src/Utils/GeoLocate.vala"
	_tmp0_ = g_settings_new ("com.gitlab.bitseater.meteo");
#line 33 "../src/Utils/GeoLocate.vala"
	setting = _tmp0_;
#line 34 "../src/Utils/GeoLocate.vala"
	_tmp1_ = g_strdup (CONSTANTS_OWM_API_ADDR "weather?lat=");
#line 34 "../src/Utils/GeoLocate.vala"
	uri1 = _tmp1_;
#line 35 "../src/Utils/GeoLocate.vala"
	_tmp2_ = g_settings_get_string (setting, "apiid");
#line 35 "../src/Utils/GeoLocate.vala"
	_tmp3_ = _tmp2_;
#line 35 "../src/Utils/GeoLocate.vala"
	_tmp4_ = g_strconcat ("&APPID=", _tmp3_, NULL);
#line 35 "../src/Utils/GeoLocate.vala"
	_tmp5_ = _tmp4_;
#line 35 "../src/Utils/GeoLocate.vala"
	_g_free0 (_tmp3_);
#line 35 "../src/Utils/GeoLocate.vala"
	uri2 = _tmp5_;
#line 37 "../src/Utils/GeoLocate.vala"
	meteo_utils_get_location (&_tmp6_);
#line 37 "../src/Utils/GeoLocate.vala"
	mycoords = _tmp6_;
#line 38 "../src/Utils/GeoLocate.vala"
	_tmp7_ = mycoords;
#line 38 "../src/Utils/GeoLocate.vala"
	_tmp8_ = mycoords;
#line 38 "../src/Utils/GeoLocate.vala"
	meteo_utils_get_names (_tmp7_.lat, _tmp8_.lon, &_tmp9_);
#line 38 "../src/Utils/GeoLocate.vala"
	mygeoloc = _tmp9_;
#line 40 "../src/Utils/GeoLocate.vala"
	_tmp10_ = mycoords;
#line 40 "../src/Utils/GeoLocate.vala"
	_tmp11_ = double_to_string (_tmp10_.lat);
#line 40 "../src/Utils/GeoLocate.vala"
	_tmp12_ = _tmp11_;
#line 40 "../src/Utils/GeoLocate.vala"
	_tmp13_ = g_strconcat (uri1, _tmp12_, NULL);
#line 40 "../src/Utils/GeoLocate.vala"
	_tmp14_ = _tmp13_;
#line 40 "../src/Utils/GeoLocate.vala"
	_tmp15_ = g_strconcat (_tmp14_, "&lon=", NULL);
#line 40 "../src/Utils/GeoLocate.vala"
	_tmp16_ = _tmp15_;
#line 40 "../src/Utils/GeoLocate.vala"
	_tmp17_ = mycoords;
#line 40 "../src/Utils/GeoLocate.vala"
	_tmp18_ = double_to_string (_tmp17_.lon);
#line 40 "../src/Utils/GeoLocate.vala"
	_tmp19_ = _tmp18_;
#line 40 "../src/Utils/GeoLocate.vala"
	_tmp20_ = g_strconcat (_tmp16_, _tmp19_, NULL);
#line 40 "../src/Utils/GeoLocate.vala"
	_tmp21_ = _tmp20_;
#line 40 "../src/Utils/GeoLocate.vala"
	_tmp22_ = g_strconcat (_tmp21_, uri2, NULL);
#line 40 "../src/Utils/GeoLocate.vala"
	_tmp23_ = _tmp22_;
#line 40 "../src/Utils/GeoLocate.vala"
	_g_free0 (_tmp21_);
#line 40 "../src/Utils/GeoLocate.vala"
	_g_free0 (_tmp19_);
#line 40 "../src/Utils/GeoLocate.vala"
	_g_free0 (_tmp16_);
#line 40 "../src/Utils/GeoLocate.vala"
	_g_free0 (_tmp14_);
#line 40 "../src/Utils/GeoLocate.vala"
	_g_free0 (_tmp12_);
#line 40 "../src/Utils/GeoLocate.vala"
	uri = _tmp23_;
#line 41 "../src/Utils/GeoLocate.vala"
	_tmp24_ = g_strdup_printf ("%" G_GINT64_FORMAT, meteo_utils_update_id (uri));
#line 41 "../src/Utils/GeoLocate.vala"
	_tmp25_ = _tmp24_;
#line 41 "../src/Utils/GeoLocate.vala"
	g_settings_set_string (setting, "idplace", _tmp25_);
#line 41 "../src/Utils/GeoLocate.vala"
	_g_free0 (_tmp25_);
#line 42 "../src/Utils/GeoLocate.vala"
	_tmp26_ = mygeoloc;
#line 42 "../src/Utils/GeoLocate.vala"
	_tmp27_ = _tmp26_.city;
#line 42 "../src/Utils/GeoLocate.vala"
	g_settings_set_string (setting, "location", _tmp27_);
#line 43 "../src/Utils/GeoLocate.vala"
	_tmp28_ = mygeoloc;
#line 43 "../src/Utils/GeoLocate.vala"
	_tmp29_ = _tmp28_.state;
#line 43 "../src/Utils/GeoLocate.vala"
	g_settings_set_string (setting, "state", _tmp29_);
#line 44 "../src/Utils/GeoLocate.vala"
	_tmp30_ = mygeoloc;
#line 44 "../src/Utils/GeoLocate.vala"
	_tmp31_ = _tmp30_.country;
#line 44 "../src/Utils/GeoLocate.vala"
	g_settings_set_string (setting, "country", _tmp31_);
#line 32 "../src/Utils/GeoLocate.vala"
	_g_free0 (uri);
#line 32 "../src/Utils/GeoLocate.vala"
	meteo_utils_geo_loc_destroy (&mygeoloc);
#line 32 "../src/Utils/GeoLocate.vala"
	_g_free0 (uri2);
#line 32 "../src/Utils/GeoLocate.vala"
	_g_free0 (uri1);
#line 32 "../src/Utils/GeoLocate.vala"
	_g_object_unref0 (setting);
#line 408 "GeoLocate.c"
}

static void
_vala_SoupBuffer_free (SoupBuffer* self)
{
#line 56 "../src/Utils/GeoLocate.vala"
	g_boxed_free (soup_buffer_get_type (), self);
#line 416 "GeoLocate.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 58 "../src/Utils/GeoLocate.vala"
	return self ? json_object_ref (self) : NULL;
#line 424 "GeoLocate.c"
}

void
meteo_utils_get_location (MeteoUtilsCoord* result)
{
	MeteoUtilsCoord coord = {0};
	gchar* uri = NULL;
	gchar* _tmp0_;
	SoupSession* session = NULL;
	SoupSession* _tmp1_;
	SoupMessage* message = NULL;
	const gchar* _tmp2_;
	SoupMessage* _tmp3_;
	SoupSession* _tmp4_;
	SoupMessage* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 48 "../src/Utils/GeoLocate.vala"
	memset (&coord, 0, sizeof (MeteoUtilsCoord));
#line 49 "../src/Utils/GeoLocate.vala"
	_tmp0_ = g_strdup ("https://location.services.mozilla.com/v1/geolocate?key=test");
#line 49 "../src/Utils/GeoLocate.vala"
	uri = _tmp0_;
#line 50 "../src/Utils/GeoLocate.vala"
	_tmp1_ = soup_session_new ();
#line 50 "../src/Utils/GeoLocate.vala"
	session = _tmp1_;
#line 51 "../src/Utils/GeoLocate.vala"
	_tmp2_ = uri;
#line 51 "../src/Utils/GeoLocate.vala"
	_tmp3_ = soup_message_new ("GET", _tmp2_);
#line 51 "../src/Utils/GeoLocate.vala"
	message = _tmp3_;
#line 52 "../src/Utils/GeoLocate.vala"
	_tmp4_ = session;
#line 52 "../src/Utils/GeoLocate.vala"
	_tmp5_ = message;
#line 52 "../src/Utils/GeoLocate.vala"
	soup_session_send_message (_tmp4_, _tmp5_);
#line 463 "GeoLocate.c"
	{
		JsonParser* parser = NULL;
		JsonParser* _tmp6_;
		JsonParser* _tmp7_;
		SoupMessage* _tmp8_;
		SoupMessageBody* _tmp9_;
		SoupBuffer* _tmp10_;
		SoupBuffer* _tmp11_;
		guint8* _tmp12_;
		gint _tmp12__length1;
		JsonObject* root = NULL;
		JsonParser* _tmp13_;
		JsonNode* _tmp14_;
		JsonObject* _tmp15_;
		JsonObject* _tmp16_;
		JsonObject* _tmp17_;
		GList* _tmp18_;
#line 55 "../src/Utils/GeoLocate.vala"
		_tmp6_ = json_parser_new ();
#line 55 "../src/Utils/GeoLocate.vala"
		parser = _tmp6_;
#line 56 "../src/Utils/GeoLocate.vala"
		_tmp7_ = parser;
#line 56 "../src/Utils/GeoLocate.vala"
		_tmp8_ = message;
#line 56 "../src/Utils/GeoLocate.vala"
		_tmp9_ = _tmp8_->response_body;
#line 56 "../src/Utils/GeoLocate.vala"
		_tmp10_ = soup_message_body_flatten (_tmp9_);
#line 56 "../src/Utils/GeoLocate.vala"
		_tmp11_ = _tmp10_;
#line 56 "../src/Utils/GeoLocate.vala"
		_tmp12_ = _tmp11_->data;
#line 56 "../src/Utils/GeoLocate.vala"
		_tmp12__length1 = _tmp11_->length;
#line 56 "../src/Utils/GeoLocate.vala"
		json_parser_load_from_data (_tmp7_, (const gchar*) _tmp12_, (gssize) -1, &_inner_error0_);
#line 56 "../src/Utils/GeoLocate.vala"
		__vala_SoupBuffer_free0 (_tmp11_);
#line 56 "../src/Utils/GeoLocate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../src/Utils/GeoLocate.vala"
			_g_object_unref0 (parser);
#line 507 "GeoLocate.c"
			goto __catch0_g_error;
		}
#line 58 "../src/Utils/GeoLocate.vala"
		_tmp13_ = parser;
#line 58 "../src/Utils/GeoLocate.vala"
		_tmp14_ = json_parser_get_root (_tmp13_);
#line 58 "../src/Utils/GeoLocate.vala"
		_tmp15_ = json_node_get_object (_tmp14_);
#line 58 "../src/Utils/GeoLocate.vala"
		_tmp16_ = _json_object_ref0 (_tmp15_);
#line 58 "../src/Utils/GeoLocate.vala"
		root = _tmp16_;
#line 60 "../src/Utils/GeoLocate.vala"
		_tmp17_ = root;
#line 60 "../src/Utils/GeoLocate.vala"
		_tmp18_ = json_object_get_members (_tmp17_);
#line 524 "GeoLocate.c"
		{
			GList* name_collection = NULL;
			GList* name_it = NULL;
#line 60 "../src/Utils/GeoLocate.vala"
			name_collection = _tmp18_;
#line 60 "../src/Utils/GeoLocate.vala"
			for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
#line 532 "GeoLocate.c"
				gchar* _tmp19_;
				gchar* name = NULL;
#line 60 "../src/Utils/GeoLocate.vala"
				_tmp19_ = g_strdup ((const gchar*) name_it->data);
#line 60 "../src/Utils/GeoLocate.vala"
				name = _tmp19_;
#line 539 "GeoLocate.c"
				{
					const gchar* _tmp20_;
#line 61 "../src/Utils/GeoLocate.vala"
					_tmp20_ = name;
#line 61 "../src/Utils/GeoLocate.vala"
					if (g_strcmp0 (_tmp20_, "location") == 0) {
#line 546 "GeoLocate.c"
						JsonObject* mycoords = NULL;
						JsonObject* _tmp21_;
						JsonObject* _tmp22_;
						JsonObject* _tmp23_;
						JsonObject* _tmp24_;
						JsonObject* _tmp25_;
#line 62 "../src/Utils/GeoLocate.vala"
						_tmp21_ = root;
#line 62 "../src/Utils/GeoLocate.vala"
						_tmp22_ = json_object_get_object_member (_tmp21_, "location");
#line 62 "../src/Utils/GeoLocate.vala"
						_tmp23_ = _json_object_ref0 (_tmp22_);
#line 62 "../src/Utils/GeoLocate.vala"
						mycoords = _tmp23_;
#line 63 "../src/Utils/GeoLocate.vala"
						_tmp24_ = mycoords;
#line 63 "../src/Utils/GeoLocate.vala"
						coord.lat = json_object_get_double_member (_tmp24_, "lat");
#line 64 "../src/Utils/GeoLocate.vala"
						_tmp25_ = mycoords;
#line 64 "../src/Utils/GeoLocate.vala"
						coord.lon = json_object_get_double_member (_tmp25_, "lng");
#line 65 "../src/Utils/GeoLocate.vala"
						_json_object_unref0 (mycoords);
#line 65 "../src/Utils/GeoLocate.vala"
						_g_free0 (name);
#line 65 "../src/Utils/GeoLocate.vala"
						break;
#line 575 "GeoLocate.c"
					} else {
						FILE* _tmp26_;
#line 67 "../src/Utils/GeoLocate.vala"
						_tmp26_ = stdout;
#line 67 "../src/Utils/GeoLocate.vala"
						fprintf (_tmp26_, "%s", _ ("Found an error"));
#line 582 "GeoLocate.c"
					}
#line 60 "../src/Utils/GeoLocate.vala"
					_g_free0 (name);
#line 586 "GeoLocate.c"
				}
			}
#line 60 "../src/Utils/GeoLocate.vala"
			(name_collection == NULL) ? NULL : (name_collection = (g_list_free (name_collection), NULL));
#line 591 "GeoLocate.c"
		}
#line 54 "../src/Utils/GeoLocate.vala"
		_json_object_unref0 (root);
#line 54 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (parser);
#line 597 "GeoLocate.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
#line 54 "../src/Utils/GeoLocate.vala"
		e = _inner_error0_;
#line 54 "../src/Utils/GeoLocate.vala"
		_inner_error0_ = NULL;
#line 71 "../src/Utils/GeoLocate.vala"
		_tmp27_ = e;
#line 71 "../src/Utils/GeoLocate.vala"
		_tmp28_ = _tmp27_->message;
#line 71 "../src/Utils/GeoLocate.vala"
		g_debug ("GeoLocate.vala:71: %s", _tmp28_);
#line 54 "../src/Utils/GeoLocate.vala"
		_g_error_free0 (e);
#line 617 "GeoLocate.c"
	}
	__finally0:
#line 54 "../src/Utils/GeoLocate.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 54 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (message);
#line 54 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (session);
#line 54 "../src/Utils/GeoLocate.vala"
		_g_free0 (uri);
#line 54 "../src/Utils/GeoLocate.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 54 "../src/Utils/GeoLocate.vala"
		g_clear_error (&_inner_error0_);
#line 54 "../src/Utils/GeoLocate.vala"
		return;
#line 634 "GeoLocate.c"
	}
#line 73 "../src/Utils/GeoLocate.vala"
	*result = coord;
#line 73 "../src/Utils/GeoLocate.vala"
	_g_object_unref0 (message);
#line 73 "../src/Utils/GeoLocate.vala"
	_g_object_unref0 (session);
#line 73 "../src/Utils/GeoLocate.vala"
	_g_free0 (uri);
#line 73 "../src/Utils/GeoLocate.vala"
	return;
#line 646 "GeoLocate.c"
}

void
meteo_utils_get_names (gdouble lat,
                       gdouble lon,
                       MeteoUtilsGeoLoc* result)
{
	MeteoUtilsGeoLoc geoloc = {0};
	gchar* url = NULL;
	gchar* _tmp0_;
	gchar* uri = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	SoupSession* session = NULL;
	SoupSession* _tmp13_;
	SoupMessage* message = NULL;
	SoupMessage* _tmp14_;
	SoupMessageHeaders* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 77 "../src/Utils/GeoLocate.vala"
	memset (&geoloc, 0, sizeof (MeteoUtilsGeoLoc));
#line 78 "../src/Utils/GeoLocate.vala"
	_tmp0_ = g_strdup ("https://nominatim.openstreetmap.org/reverse?format=json&zoom=10&");
#line 78 "../src/Utils/GeoLocate.vala"
	url = _tmp0_;
#line 79 "../src/Utils/GeoLocate.vala"
	_tmp1_ = g_strconcat (url, "lat=", NULL);
#line 79 "../src/Utils/GeoLocate.vala"
	_tmp2_ = _tmp1_;
#line 79 "../src/Utils/GeoLocate.vala"
	_tmp3_ = double_to_string (lat);
#line 79 "../src/Utils/GeoLocate.vala"
	_tmp4_ = _tmp3_;
#line 79 "../src/Utils/GeoLocate.vala"
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
#line 79 "../src/Utils/GeoLocate.vala"
	_tmp6_ = _tmp5_;
#line 79 "../src/Utils/GeoLocate.vala"
	_tmp7_ = g_strconcat (_tmp6_, "&lon=", NULL);
#line 79 "../src/Utils/GeoLocate.vala"
	_tmp8_ = _tmp7_;
#line 79 "../src/Utils/GeoLocate.vala"
	_tmp9_ = double_to_string (lon);
#line 79 "../src/Utils/GeoLocate.vala"
	_tmp10_ = _tmp9_;
#line 79 "../src/Utils/GeoLocate.vala"
	_tmp11_ = g_strconcat (_tmp8_, _tmp10_, NULL);
#line 79 "../src/Utils/GeoLocate.vala"
	_tmp12_ = _tmp11_;
#line 79 "../src/Utils/GeoLocate.vala"
	_g_free0 (_tmp10_);
#line 79 "../src/Utils/GeoLocate.vala"
	_g_free0 (_tmp8_);
#line 79 "../src/Utils/GeoLocate.vala"
	_g_free0 (_tmp6_);
#line 79 "../src/Utils/GeoLocate.vala"
	_g_free0 (_tmp4_);
#line 79 "../src/Utils/GeoLocate.vala"
	_g_free0 (_tmp2_);
#line 79 "../src/Utils/GeoLocate.vala"
	uri = _tmp12_;
#line 80 "../src/Utils/GeoLocate.vala"
	_tmp13_ = soup_session_new ();
#line 80 "../src/Utils/GeoLocate.vala"
	session = _tmp13_;
#line 81 "../src/Utils/GeoLocate.vala"
	_tmp14_ = soup_message_new ("GET", uri);
#line 81 "../src/Utils/GeoLocate.vala"
	message = _tmp14_;
#line 82 "../src/Utils/GeoLocate.vala"
	_tmp15_ = message->request_headers;
#line 82 "../src/Utils/GeoLocate.vala"
	soup_message_headers_append (_tmp15_, "User-Agent", "com.gitlab.bitseater.meteo");
#line 83 "../src/Utils/GeoLocate.vala"
	soup_session_send_message (session, message);
#line 732 "GeoLocate.c"
	{
		JsonParser* parser = NULL;
		JsonParser* _tmp16_;
		SoupMessageBody* _tmp17_;
		SoupBuffer* _tmp18_;
		SoupBuffer* _tmp19_;
		guint8* _tmp20_;
		gint _tmp20__length1;
		JsonObject* root = NULL;
		JsonNode* _tmp21_;
		JsonObject* _tmp22_;
		JsonObject* _tmp23_;
		JsonObject* mygeoloc = NULL;
		JsonObject* _tmp24_;
		JsonObject* _tmp25_;
		JsonObject* _tmp26_;
		JsonObject* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		JsonObject* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		JsonObject* _tmp33_;
		const gchar* _tmp34_;
		gchar* _tmp35_;
#line 86 "../src/Utils/GeoLocate.vala"
		_tmp16_ = json_parser_new ();
#line 86 "../src/Utils/GeoLocate.vala"
		parser = _tmp16_;
#line 87 "../src/Utils/GeoLocate.vala"
		_tmp17_ = message->response_body;
#line 87 "../src/Utils/GeoLocate.vala"
		_tmp18_ = soup_message_body_flatten (_tmp17_);
#line 87 "../src/Utils/GeoLocate.vala"
		_tmp19_ = _tmp18_;
#line 87 "../src/Utils/GeoLocate.vala"
		_tmp20_ = _tmp19_->data;
#line 87 "../src/Utils/GeoLocate.vala"
		_tmp20__length1 = _tmp19_->length;
#line 87 "../src/Utils/GeoLocate.vala"
		json_parser_load_from_data (parser, (const gchar*) _tmp20_, (gssize) -1, &_inner_error0_);
#line 87 "../src/Utils/GeoLocate.vala"
		__vala_SoupBuffer_free0 (_tmp19_);
#line 87 "../src/Utils/GeoLocate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 87 "../src/Utils/GeoLocate.vala"
			_g_object_unref0 (parser);
#line 780 "GeoLocate.c"
			goto __catch0_g_error;
		}
#line 88 "../src/Utils/GeoLocate.vala"
		_tmp21_ = json_parser_get_root (parser);
#line 88 "../src/Utils/GeoLocate.vala"
		_tmp22_ = json_node_get_object (_tmp21_);
#line 88 "../src/Utils/GeoLocate.vala"
		_tmp23_ = _json_object_ref0 (_tmp22_);
#line 88 "../src/Utils/GeoLocate.vala"
		root = _tmp23_;
#line 89 "../src/Utils/GeoLocate.vala"
		_tmp24_ = root;
#line 89 "../src/Utils/GeoLocate.vala"
		_tmp25_ = json_object_get_object_member (_tmp24_, "address");
#line 89 "../src/Utils/GeoLocate.vala"
		_tmp26_ = _json_object_ref0 (_tmp25_);
#line 89 "../src/Utils/GeoLocate.vala"
		mygeoloc = _tmp26_;
#line 90 "../src/Utils/GeoLocate.vala"
		_tmp27_ = mygeoloc;
#line 90 "../src/Utils/GeoLocate.vala"
		_tmp28_ = json_object_get_string_member (_tmp27_, "city");
#line 90 "../src/Utils/GeoLocate.vala"
		_tmp29_ = g_strdup (_tmp28_);
#line 90 "../src/Utils/GeoLocate.vala"
		_g_free0 (geoloc.city);
#line 90 "../src/Utils/GeoLocate.vala"
		geoloc.city = _tmp29_;
#line 91 "../src/Utils/GeoLocate.vala"
		_tmp30_ = mygeoloc;
#line 91 "../src/Utils/GeoLocate.vala"
		_tmp31_ = json_object_get_string_member (_tmp30_, "state");
#line 91 "../src/Utils/GeoLocate.vala"
		_tmp32_ = g_strdup (_tmp31_);
#line 91 "../src/Utils/GeoLocate.vala"
		_g_free0 (geoloc.state);
#line 91 "../src/Utils/GeoLocate.vala"
		geoloc.state = _tmp32_;
#line 92 "../src/Utils/GeoLocate.vala"
		_tmp33_ = mygeoloc;
#line 92 "../src/Utils/GeoLocate.vala"
		_tmp34_ = json_object_get_string_member (_tmp33_, "country_code");
#line 92 "../src/Utils/GeoLocate.vala"
		_tmp35_ = g_utf8_strup (_tmp34_, (gssize) -1);
#line 92 "../src/Utils/GeoLocate.vala"
		_g_free0 (geoloc.country);
#line 92 "../src/Utils/GeoLocate.vala"
		geoloc.country = _tmp35_;
#line 85 "../src/Utils/GeoLocate.vala"
		_json_object_unref0 (mygeoloc);
#line 85 "../src/Utils/GeoLocate.vala"
		_json_object_unref0 (root);
#line 85 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (parser);
#line 835 "GeoLocate.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp36_;
		const gchar* _tmp37_;
#line 85 "../src/Utils/GeoLocate.vala"
		e = _inner_error0_;
#line 85 "../src/Utils/GeoLocate.vala"
		_inner_error0_ = NULL;
#line 94 "../src/Utils/GeoLocate.vala"
		_tmp36_ = e;
#line 94 "../src/Utils/GeoLocate.vala"
		_tmp37_ = _tmp36_->message;
#line 94 "../src/Utils/GeoLocate.vala"
		g_debug ("GeoLocate.vala:94: %s", _tmp37_);
#line 85 "../src/Utils/GeoLocate.vala"
		_g_error_free0 (e);
#line 855 "GeoLocate.c"
	}
	__finally0:
#line 85 "../src/Utils/GeoLocate.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (message);
#line 85 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (session);
#line 85 "../src/Utils/GeoLocate.vala"
		_g_free0 (uri);
#line 85 "../src/Utils/GeoLocate.vala"
		_g_free0 (url);
#line 85 "../src/Utils/GeoLocate.vala"
		meteo_utils_geo_loc_destroy (&geoloc);
#line 85 "../src/Utils/GeoLocate.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../src/Utils/GeoLocate.vala"
		g_clear_error (&_inner_error0_);
#line 85 "../src/Utils/GeoLocate.vala"
		return;
#line 876 "GeoLocate.c"
	}
#line 96 "../src/Utils/GeoLocate.vala"
	*result = geoloc;
#line 96 "../src/Utils/GeoLocate.vala"
	_g_object_unref0 (message);
#line 96 "../src/Utils/GeoLocate.vala"
	_g_object_unref0 (session);
#line 96 "../src/Utils/GeoLocate.vala"
	_g_free0 (uri);
#line 96 "../src/Utils/GeoLocate.vala"
	_g_free0 (url);
#line 96 "../src/Utils/GeoLocate.vala"
	return;
#line 890 "GeoLocate.c"
}

gint64
meteo_utils_update_id (const gchar* uri)
{
	SoupSession* session = NULL;
	SoupSession* _tmp0_;
	SoupMessage* message = NULL;
	SoupMessage* _tmp1_;
	gint64 id = 0LL;
	GError* _inner_error0_ = NULL;
	gint64 result;
#line 99 "../src/Utils/GeoLocate.vala"
	g_return_val_if_fail (uri != NULL, 0LL);
#line 100 "../src/Utils/GeoLocate.vala"
	_tmp0_ = soup_session_new ();
#line 100 "../src/Utils/GeoLocate.vala"
	session = _tmp0_;
#line 101 "../src/Utils/GeoLocate.vala"
	_tmp1_ = soup_message_new ("GET", uri);
#line 101 "../src/Utils/GeoLocate.vala"
	message = _tmp1_;
#line 102 "../src/Utils/GeoLocate.vala"
	soup_session_send_message (session, message);
#line 103 "../src/Utils/GeoLocate.vala"
	id = (gint64) 0;
#line 917 "GeoLocate.c"
	{
		JsonParser* parser = NULL;
		JsonParser* _tmp2_;
		SoupMessageBody* _tmp3_;
		SoupBuffer* _tmp4_;
		SoupBuffer* _tmp5_;
		guint8* _tmp6_;
		gint _tmp6__length1;
		JsonObject* root = NULL;
		JsonNode* _tmp7_;
		JsonObject* _tmp8_;
		JsonObject* _tmp9_;
		JsonObject* _tmp10_;
#line 105 "../src/Utils/GeoLocate.vala"
		_tmp2_ = json_parser_new ();
#line 105 "../src/Utils/GeoLocate.vala"
		parser = _tmp2_;
#line 106 "../src/Utils/GeoLocate.vala"
		_tmp3_ = message->response_body;
#line 106 "../src/Utils/GeoLocate.vala"
		_tmp4_ = soup_message_body_flatten (_tmp3_);
#line 106 "../src/Utils/GeoLocate.vala"
		_tmp5_ = _tmp4_;
#line 106 "../src/Utils/GeoLocate.vala"
		_tmp6_ = _tmp5_->data;
#line 106 "../src/Utils/GeoLocate.vala"
		_tmp6__length1 = _tmp5_->length;
#line 106 "../src/Utils/GeoLocate.vala"
		json_parser_load_from_data (parser, (const gchar*) _tmp6_, (gssize) -1, &_inner_error0_);
#line 106 "../src/Utils/GeoLocate.vala"
		__vala_SoupBuffer_free0 (_tmp5_);
#line 106 "../src/Utils/GeoLocate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../src/Utils/GeoLocate.vala"
			_g_object_unref0 (parser);
#line 953 "GeoLocate.c"
			goto __catch0_g_error;
		}
#line 107 "../src/Utils/GeoLocate.vala"
		_tmp7_ = json_parser_get_root (parser);
#line 107 "../src/Utils/GeoLocate.vala"
		_tmp8_ = json_node_get_object (_tmp7_);
#line 107 "../src/Utils/GeoLocate.vala"
		_tmp9_ = _json_object_ref0 (_tmp8_);
#line 107 "../src/Utils/GeoLocate.vala"
		root = _tmp9_;
#line 108 "../src/Utils/GeoLocate.vala"
		_tmp10_ = root;
#line 108 "../src/Utils/GeoLocate.vala"
		id = json_object_get_int_member (_tmp10_, "id");
#line 104 "../src/Utils/GeoLocate.vala"
		_json_object_unref0 (root);
#line 104 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (parser);
#line 972 "GeoLocate.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 104 "../src/Utils/GeoLocate.vala"
		e = _inner_error0_;
#line 104 "../src/Utils/GeoLocate.vala"
		_inner_error0_ = NULL;
#line 110 "../src/Utils/GeoLocate.vala"
		_tmp11_ = e;
#line 110 "../src/Utils/GeoLocate.vala"
		_tmp12_ = _tmp11_->message;
#line 110 "../src/Utils/GeoLocate.vala"
		g_debug ("GeoLocate.vala:110: %s", _tmp12_);
#line 104 "../src/Utils/GeoLocate.vala"
		_g_error_free0 (e);
#line 992 "GeoLocate.c"
	}
	__finally0:
#line 104 "../src/Utils/GeoLocate.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 997 "GeoLocate.c"
		gint64 _tmp13_ = -1LL;
#line 104 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (message);
#line 104 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (session);
#line 104 "../src/Utils/GeoLocate.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 104 "../src/Utils/GeoLocate.vala"
		g_clear_error (&_inner_error0_);
#line 104 "../src/Utils/GeoLocate.vala"
		return _tmp13_;
#line 1009 "GeoLocate.c"
	}
#line 112 "../src/Utils/GeoLocate.vala"
	result = id;
#line 112 "../src/Utils/GeoLocate.vala"
	_g_object_unref0 (message);
#line 112 "../src/Utils/GeoLocate.vala"
	_g_object_unref0 (session);
#line 112 "../src/Utils/GeoLocate.vala"
	return result;
#line 1019 "GeoLocate.c"
}

